import fetchMock from 'fetch-mock';

const mockSpies = [jest.spyOn(fetchMock, 'mock'), jest.spyOn(fetchMock, 'get'), jest.spyOn(fetchMock, 'put'), jest.spyOn(fetchMock, 'post'), jest.spyOn(fetchMock, 'delete')];
const restoreSpy = jest.spyOn(fetchMock, 'restore');
function isMocked() {
  const wasMocked = mockSpies.some(spy => spy.mock.calls.length > 0);
  const wasRestored = restoreSpy.mock.calls.length > 0;
  return wasMocked && !wasRestored;
}
const augmentedFetchMock = fetchMock;
augmentedFetchMock.isMocked = isMocked;
var fetch = augmentedFetchMock;

export { fetch as default };
