declare enum SupportedDimension {
    InnerWidth = "innerWidth",
    OffsetWidth = "offsetWidth",
    OffsetHeight = "offsetHeight",
    ScrollWidth = "scrollWidth",
    ScrollHeight = "scrollHeight"
}
type NumberOrGetter = number | ((element: HTMLElement | Element) => number);
type MockedDimensions = {
    [T in SupportedDimension]: NumberOrGetter;
};
export default class Dimension {
    private dimensionMap;
    private undoMocks;
    mock(mocks: Partial<MockedDimensions>): void;
    restore(): void;
    isMocked(): boolean;
    private applyMocks;
}
export {};
//# sourceMappingURL=dimension.d.ts.map